<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/__init__.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">import</span> os, stat</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">try</span>:</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">    <span class="py-keyword">import</span> hashlib</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">    md5 = hashlib.md5</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">except</span> ImportError:</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">    <span class="py-comment"># 2.4 compatibility</span></span>
<a id="line14"></a><span class="lineno">14</span><span class="line">    <span class="py-keyword">import</span> md5</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    md5 = md5.new</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Formatters.html#quote_name">quote_name</a>(name):</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Quotes a (file-) name to remove illegal characters and keep it</span></span>
<a id="line20"></a><span class="lineno">20</span><span class="line"><span class="py-string">    within a reasonable length for the filesystem.</span></span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="py-string">   </span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="py-string">    The md5 hash function is used if the length of the name after quoting is</span></span>
<a id="line23"></a><span class="lineno">23</span><span class="line"><span class="py-string">    more than 100 characters. If it is used, then as many characters at the</span></span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="py-string">    start of the name as possible are kept intact, and the hash appended to</span></span>
<a id="line25"></a><span class="lineno">25</span><span class="line"><span class="py-string">    make 100 characters.</span></span>
<a id="line26"></a><span class="lineno">26</span><span class="line"><span class="py-string">   </span></span>
<a id="line27"></a><span class="lineno">27</span><span class="line"><span class="py-string">    Do not pass filenames with meaningful extensions to this function, as the</span></span>
<a id="line28"></a><span class="lineno">28</span><span class="line"><span class="py-string">    hash could destroy them.&quot;&quot;&quot;</span></span>
<a id="line29"></a><span class="lineno">29</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">    original = name <span class="py-comment"># save the old name</span></span>
<a id="line31"></a><span class="lineno">31</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">    <span class="py-comment"># a . is usually an extension, eg source page filename: &quot;_page-foo.hpp&quot; + .html</span></span>
<a id="line33"></a><span class="lineno">33</span><span class="line">    <span class="py-comment"># name = re.sub('\.','_',name) </span></span>
<a id="line34"></a><span class="lineno">34</span><span class="line">    <span class="py-comment"># The . is arbitrary..</span></span>
<a id="line35"></a><span class="lineno">35</span><span class="line">    <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">'&lt;'</span>, <span class="py-string">'.L'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'.R'</span>), (<span class="py-string">'('</span>, <span class="py-string">'.l'</span>), (<span class="py-string">')'</span>, <span class="py-string">'.r'</span>), (<span class="py-string">'::'</span>, <span class="py-string">'-'</span>),</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">              (<span class="py-string">':'</span>, <span class="py-string">'.'</span>), (<span class="py-string">'&amp;'</span>, <span class="py-string">'.A'</span>), (<span class="py-string">'*'</span>, <span class="py-string">'.S'</span>), (<span class="py-string">' '</span>, <span class="py-string">'.s'</span>), (<span class="py-string">','</span>, <span class="py-string">'.c'</span>), (<span class="py-string">';'</span>, <span class="py-string">'.C'</span>)]:</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        name = name.replace(*p)</span>
<a id="line38"></a><span class="lineno">38</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">    <span class="py-keyword">if</span> len(name) &gt; 100:</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        digest = md5(original).hexdigest()</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-comment"># Keep as much of the name as possible</span></span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        name = name[:100 - len(digest)] + digest</span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">    <span class="py-keyword">return</span> name</span>
<a id="line45"></a><span class="lineno">45</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Formatters.html#open_file">open_file</a>(path, mode=511):</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Open a file for writing. Create all intermediate directories.&quot;&quot;&quot;</span></span>
<a id="line49"></a><span class="lineno">49</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">    directory = os.path.dirname(path)</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">    <span class="py-keyword">if</span> directory <span class="py-keyword">and</span> <span class="py-keyword">not</span> os.path.isdir(directory):</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        os.makedirs(directory, mode)</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">    <span class="py-keyword">return</span> open(path, <span class="py-string">'w+'</span>)</span>
<a id="line54"></a><span class="lineno">54</span>
<a id="line55"></a><span class="lineno">55</span>
<a id="line56"></a><span class="lineno">56</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Formatters.html#copy_file">copy_file</a>(src, dest):</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Copy src to dest, if dest doesn't exist yet or is outdated.&quot;&quot;&quot;</span></span>
<a id="line58"></a><span class="lineno">58</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">    filetime = os.stat(src)[stat.ST_MTIME]</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">    <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.exists(dest) <span class="py-keyword">or</span> filetime &gt; os.stat(dest)[stat.ST_MTIME]:</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        open_file(dest).write(open(src, <span class="py-string">'r'</span>).read())</span>
<a id="line62"></a><span class="lineno">62</span>
<a id="line63"></a><span class="lineno">63</span>
<a id="line64"></a><span class="lineno">64</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Formatters.html#join_paths">join_paths</a>(prefix, path):</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line66"></a><span class="lineno">66</span><span class="line"><span class="py-string">    This function joins `prefix` and `path`, irrespectively of whether</span></span>
<a id="line67"></a><span class="lineno">67</span><span class="line"><span class="py-string">    `path` is absolute or not. To do this portably is non-trivial.&quot;&quot;&quot;</span></span>
<a id="line68"></a><span class="lineno">68</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">    <span class="py-comment"># FIXME: Figure out how to do this portably.</span></span>
<a id="line70"></a><span class="lineno">70</span><span class="line">    <span class="py-keyword">if</span> path.startswith(<span class="py-string">'/'</span>):</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        path = path[1:]</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">    <span class="py-keyword">return</span> os.path.join(prefix, path)</span>
<a id="line73"></a><span class="lineno">73</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
